#include "int_test.h"
#include "EM_GeneralWrapper.h"
#include "dpc_em/executable.h"


void setup_test()
{
	// Logger for wrapper
	// ara headers must be added
	ara::log::InitLogging("DPC", "EM_TEST", ara::log::LogLevel::kVerbose, (ara::log::LogMode::kConsole | ara::log::LogMode::kRemote));

	ara::log::Logger &mainLog { ara::log::CreateLogger("main", "em sample context", ara::log::LogLevel::kVerbose) };

	mainLog.LogInfo() << "Let's produce some em data...";
	GeneralWrapper gw(mainLog);
	dpc::LaneMarkerInfo data;
	uint16_t counter = 0;
	while(1)
	{
		counter++;
		// gw._EM2TRPCLongTargetsInfo_Provide.s.SetData(counter);
		//gw._EM2TRPCLongLaneMarkerInfo_Provide.Publish();

	  gw._EM2TRPCLongTargetsInfo_Provide.Publish();
      gw._EM2TRPCLongTargetInfo_Provide.Publish();
      gw._EM2TRPCLongRoadEdgeInfo_Provide.Publish();
      gw._EM2TRPCLongLaneMarkerInfo_Provide.Publish();
      gw._EM2DMRoadInfo_Provide.Publish();
      gw._EM2DMRMHeader_Provide.Publish();
      gw._EM2DMIndex_Provide.Publish();
      gw._EM2DMCarPosition_Provide.Publish();
      gw._EM2DMLane_Provide.Publish();
      gw._EM2DMLaneMarker_Provide.Publish();
      gw._EM2DMObject_Provide.Publish();
      gw._EM2DMRoadEdge_Provide.Publish();
      gw._EM2DMNeighborLane_Provide.Publish();
      gw._EM2DMCorridor_Provide.Publish();
      gw._EM2DMSamplingPoint_Provide.Publish();
      gw._EM2DMLineColor_Provide.Publish();
      gw._EM2DMLineType_Provide.Publish();
      gw._EM2DMObjectLocation_Provide.Publish();
      gw._EM2DMSLPoint_Provide.Publish();
      gw._EM2DMLaneControl_Provide.Publish();
      gw._EM2DMLaneBoundary_Provide.Publish();
      gw._EM2DMLineGeometry_Provide.Publish();
      gw._EM2DMRoadEdgeSegment_Provide.Publish();
      gw._EM2SMRMSMMessage_Provide.Publish();
      gw._EM2SMLaneInfo_Provide.Publish();
      gw._EM2SMLeftLine_Provide.Publish();
      gw._EM2SMRightLine_Provide.Publish();
      gw._EM2SMRightRoadEdge_Provide.Publish();
      gw._EM2SMLeftRoadEdge_Provide.Publish();
      gw._EM2SMODDInfo_Provide.Publish();
      gw._EM2SMRMEgoLftLnegeometry_Provide.Publish();
      gw._EM2SMRMEgoRgtLnegeometry_Provide.Publish();
      gw._EM2SMRMRdEdgeLftgeometry_Provide.Publish();
      gw._EM2SMRMRdEdgeRgtgeometry_Provide.Publish();
		std::this_thread::sleep_for(std::chrono::milliseconds(300));
}
}
